"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
// src/jy_draft/create_draft.js
var _require = require('uuid'),
  uuidv4 = _require.v4;
var _require2 = require('./TextMaterial'),
  TextMaterial = _require2.TextMaterial;
var _require3 = require('./Track'),
  Track = _require3.Track,
  TrackTypes = _require3.TrackTypes;
var _require4 = require('./AudioMaterial'),
  AudioMaterial = _require4.AudioMaterial;
var _require5 = require('./VideoMaterial'),
  VideoMaterial = _require5.VideoMaterial,
  MATERIAL_TYPE = _require5.MATERIAL_TYPE;
var _require6 = require('./Effects'),
  Effects = _require6.Effects;
var _require7 = require('./Stickers'),
  Stickers = _require7.Stickers;
var _require8 = require('./Transitions'),
  Transitions = _require8.Transitions;
var _require9 = require('./add_text_animations'),
  add_text_animations = _require9.add_text_animations;
var _require10 = require('./add_video_animations'),
  add_video_animations = _require10.add_video_animations;

// 获取所有的文字动画
var _require11 = require('./data/text/text_animations'),
  _get_all_ruchang_Effects = _require11.get_all_ruchang_Effects;
var _require12 = require('./data/text/text_animations'),
  _get_all_chuchang_Effects = _require12.get_all_chuchang_Effects;
var _require13 = require('./data/text/text_animations'),
  _get_all_loop_Effects = _require13.get_all_loop_Effects;

// 获取所有的图片动画
var _require14 = require('./data/video/video_animations'),
  _get_all_video_ruchang_Effects = _require14.get_all_video_ruchang_Effects;
var _require15 = require('./data/video/video_animations'),
  _get_all_video_chuchang_Effects = _require15.get_all_video_chuchang_Effects;
var _require16 = require('./data/video/video_animations'),
  _get_all_video_loop_Effects = _require16.get_all_video_loop_Effects;

//获取音频特效
var _require17 = require('./data/audio/audio_effect'),
  get_all_audio_effects = _require17.get_all_audio_effects,
  find_audio_effect_by_title = _require17.find_audio_effect_by_title;

// mask
var _require18 = require('./Mask'),
  MaskMeta = _require18.MaskMeta,
  MaskType = _require18.MaskType,
  Mask = _require18.Mask;
var _require19 = require('./Segments'),
  Segments = _require19.Segments;
var _require20 = require('./Qipaos'),
  Qipaos = _require20.Qipaos;
var _require21 = require('./data/text/qipao'),
  _get_all_qipao = _require21.get_all_qipao;
var Draft = /*#__PURE__*/function () {
  function Draft() {
    var width = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1080;
    var height = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1080;
    _classCallCheck(this, Draft);
    this.canvas_config = {
      height: height,
      ratio: "original",
      width: width
    };
    this.color_space = -1;
    this.config = {
      adjust_max_index: 1,
      attachment_info: [],
      combination_max_index: 1,
      export_range: null,
      extract_audio_last_index: 1,
      lyrics_recognition_id: "",
      lyrics_sync: true,
      lyrics_taskinfo: [],
      maintrack_adsorb: true,
      material_save_mode: 0,
      multi_language_current: "none",
      multi_language_list: [],
      multi_language_main: "none",
      multi_language_mode: "none",
      original_sound_last_index: 1,
      record_audio_last_index: 1,
      sticker_max_index: 1,
      subtitle_keywords_config: null,
      subtitle_recognition_id: "",
      subtitle_sync: true,
      subtitle_taskinfo: [],
      system_font_list: [],
      video_mute: false,
      zoom_info_params: null
    };
    this.cover = null;
    this.create_time = 0;
    this.duration = 0;
    this.extra_info = null;
    this.fps = 30.0;
    this.free_render_index_mode_on = false;
    this.group_container = null;
    this.id = uuidv4();
    this.is_drop_frame_timecode = false;
    this.keyframe_graph_list = [];
    this.keyframes = {
      adjusts: [],
      audios: [],
      effects: [],
      filters: [],
      handwrites: [],
      stickers: [],
      texts: [],
      videos: []
    };
    this.lyrics_effects = [];
    this.materials = {
      ai_translates: [],
      audio_balances: [],
      audio_effects: [],
      audio_fades: [],
      audio_track_indexes: [],
      audios: [],
      beats: [],
      canvases: [],
      chromas: [],
      color_curves: [],
      masks: [],
      digital_humans: [],
      drafts: [],
      effects: [],
      flowers: [],
      green_screens: [],
      handwrites: [],
      hsl: [],
      images: [],
      log_color_wheels: [],
      loudnesses: [],
      manual_deformations: [],
      material_animations: [],
      material_colors: [],
      multi_language_refs: [],
      placeholder_infos: [],
      placeholders: [],
      plugin_effects: [],
      primary_color_wheels: [],
      realtime_denoises: [],
      shapes: [],
      smart_crops: [],
      smart_relights: [],
      sound_channel_mappings: [],
      speeds: [],
      stickers: [],
      tail_leaders: [],
      text_templates: [],
      texts: [],
      time_marks: [],
      transitions: [],
      video_effects: [],
      video_trackings: [],
      videos: [],
      vocal_beautifys: [],
      vocal_separations: []
    };
    this.mutable_config = null;
    this.name = "";
    this.new_version = "128.0.0";
    this.path = "";
    this.relationships = [];
    this.render_index_track_mode_on = true;
    this.retouch_cover = null;
    this.source = "default";
    this.static_cover_image_path = "";
    this.time_marks = null;
    this.tracks = [{
      attribute: 0,
      flag: 0,
      id: "2D0629D7-BC55-4A90-867A-C078CFEEE0D2",
      segments: [],
      type: "video"
    }];
    this.update_time = 0;
    this.version = 360000;
    this.new_version = "110.0.0";
    this.platform = {
      app_id: 3704,
      app_source: "lv",
      app_version: "5.9.0",
      device_id: "9d624d7e23dc4e43a0ed4020b8e3e90e",
      hard_disk_id: "f242a67014ec01ecdc2a9280da37adb1",
      mac_address: "0c233adaa327abd93e3d6b5dae6d75e2",
      os: "mac",
      os_version: "14.5"
    };
    this.last_modified_platform = {
      app_id: 3704,
      app_source: "cc",
      app_version: "5.9.0",
      device_id: "9d624d7e23dc4e43a0ed4020b8e3e90e",
      hard_disk_id: "f242a67014ec01ecdc2a9280da37adb1",
      mac_address: "0c233adaa327abd93e3d6b5dae6d75e2",
      os: "mac",
      os_version: "14.5"
    };
  }

  //创建蒙版
  return _createClass(Draft, [{
    key: "create_mask",
    value: function create_mask(mask_title) {
      var mask = new Mask(mask_title);
      this.materials.masks.push(mask);
      return mask;
    }

    //创建文字内容
  }, {
    key: "create_materials_subtitle",
    value: function create_materials_subtitle(text) {
      var text_material = new TextMaterial(text);
      this.materials.texts.push(text_material);
      return text_material;
    }

    //创建气泡
  }, {
    key: "create_materials_qipao",
    value: function create_materials_qipao(resource_id) {
      var qipao = new Qipaos(resource_id);
      this.materials.effects.push(qipao);
      return qipao;
    }

    //获取所有气泡
  }, {
    key: "get_all_qipao",
    value: function get_all_qipao() {
      return _get_all_qipao();
    }

    //创建音频内容
  }, {
    key: "create_materials_audio",
    value: function create_materials_audio(audio_path, duration) {
      var audio_material = new AudioMaterial(audio_path, duration);
      this.materials.audios.push(audio_material);
      return audio_material;
    }

    //创建音频特效 audio_effects
    // 创建音频特效
  }, {
    key: "create_materials_audio_effects",
    value: function create_materials_audio_effects(effect_title) {
      // 从环境音效库中查找匹配的音频特效
      var effect_data = find_audio_effect_by_title(effect_title);
      // 添加到素材库
      this.materials.audio_effects.push(effect_data);
      return effect_data;
    }

    //创建视频内容
  }, {
    key: "create_materials_video",
    value: function create_materials_video(video_path) {
      var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5 * 1000 * 1000;
      var width = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1080;
      var height = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1080;
      var type = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : MATERIAL_TYPE.VIDEO;
      var video_material = new VideoMaterial(video_path, duration, width, height, type);
      this.materials.videos.push(video_material);
      return video_material;
    }

    //创建特效
  }, {
    key: "create_materials_video_effects",
    value: function create_materials_video_effects(effect_title) {
      var video_effects = new Effects(effect_title);
      this.materials.video_effects.push(video_effects);
      return video_effects;
    }

    //创建贴纸
  }, {
    key: "create_materials_stickers",
    value: function create_materials_stickers(sticker_id) {
      var stickers = new Stickers(sticker_id);
      this.materials.stickers.push(stickers);
      return stickers;
    }

    //创建转场
  }, {
    key: "create_materials_transitions",
    value: function create_materials_transitions(effect_id) {
      var transitions = new Transitions(effect_id);
      this.materials.transitions.push(transitions);
      return transitions;
    }

    //创建文字动画
  }, {
    key: "create_materials_text_animations",
    value: function create_materials_text_animations() {
      var ruchang_resource_id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      var chuchang_resource_id = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
      var xuhuan_resource_id = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";
      var text_animations = add_text_animations(ruchang_resource_id, chuchang_resource_id, xuhuan_resource_id);
      this.materials.material_animations.push(text_animations);
      return text_animations;
    }

    //获取所有的文字入场动画 mode 0 all 1 vip 2 free
  }, {
    key: "get_all_ruchang_Effects",
    value: function get_all_ruchang_Effects(mode) {
      return _get_all_ruchang_Effects(mode);
    }

    //获取所有的文字出场动画
  }, {
    key: "get_all_chuchang_Effects",
    value: function get_all_chuchang_Effects(mode) {
      return _get_all_chuchang_Effects(mode);
    }

    //获取所有的文字循环动画
  }, {
    key: "get_all_loop_Effects",
    value: function get_all_loop_Effects(mode) {
      return _get_all_loop_Effects(mode);
    }

    //获取所有的图片入场动画
  }, {
    key: "get_all_video_ruchang_Effects",
    value: function get_all_video_ruchang_Effects(mode) {
      return _get_all_video_ruchang_Effects(mode);
    }

    //获取所有的图片出场动画
  }, {
    key: "get_all_video_chuchang_Effects",
    value: function get_all_video_chuchang_Effects(mode) {
      return _get_all_video_chuchang_Effects(mode);
    }

    //获取所有的图片循环动画
  }, {
    key: "get_all_video_loop_Effects",
    value: function get_all_video_loop_Effects(mode) {
      return _get_all_video_loop_Effects(mode);
    }

    //创建图片动画
  }, {
    key: "create_materials_image_animations",
    value: function create_materials_image_animations() {
      var in_title = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      var out_title = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
      var loop_title = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";
      var image_animations = add_video_animations(in_title, out_title, loop_title);
      this.materials.material_animations.push(image_animations);
      return image_animations;
    }

    //创建轨道
  }, {
    key: "add_tracks",
    value: function add_tracks() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'text';
      var track = new Track(type);
      this.tracks.push(track);
      return track;
    }

    //获取轨道by id
  }, {
    key: "get_track_by_id",
    value: function get_track_by_id(id) {
      return this.tracks.find(function (track) {
        return track.id === id;
      });
    }

    //获取segment by id
  }, {
    key: "get_segment_by_id",
    value: function get_segment_by_id(id) {
      var _iterator = _createForOfIteratorHelper(this.tracks),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var track = _step.value;
          var segment = track.segments.find(function (segment) {
            return segment.id === id;
          });
          if (segment) {
            // 创建一个新的 Segments 实例
            var newSegment = new Segments(segment.material_id, segment.target_timerange.start, segment.target_timerange.duration);

            // 复制所有属性到新的 Segments 对象
            Object.assign(newSegment, segment);
            return newSegment;
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      return null; // 如果没有找到匹配的segment，返回null
    }

    // 从JSON字符串创建Draft对象的静态方法
  }], [{
    key: "fromJSON",
    value: function fromJSON(jsonString) {
      try {
        var _data$canvas_config, _data$canvas_config2;
        var data = JSON.parse(jsonString);
        var draft = new Draft((_data$canvas_config = data.canvas_config) === null || _data$canvas_config === void 0 ? void 0 : _data$canvas_config.width, (_data$canvas_config2 = data.canvas_config) === null || _data$canvas_config2 === void 0 ? void 0 : _data$canvas_config2.height);

        // 复制所有属性到新的draft对象
        Object.assign(draft, data);
        return draft;
      } catch (error) {
        throw new Error("\u89E3\u6790Draft JSON\u65F6\u51FA\u9519: ".concat(error.message));
      }
    }
  }]);
}();
module.exports = {
  Draft: Draft
};