"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
var _require = require('uuid'),
  uuidv4 = _require.v4;
var _require2 = require('./data/effect/cn/effect'),
  find_effect_by_title = _require2.find_effect_by_title;
var Effects = /*#__PURE__*/_createClass(function Effects(effect_title) {
  _classCallCheck(this, Effects);
  var effect = find_effect_by_title(effect_title);
  this.adjust_params = [];
  var sdk_extra = JSON.parse(effect.common_attr.sdk_extra);
  var effect_adjust_params = sdk_extra.setting.effect_adjust_params;
  var _iterator = _createForOfIteratorHelper(effect_adjust_params),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var param = _step.value;
      this.adjust_params.push({
        "default_value": param["default"],
        "name": param.effect_key,
        "value": param["default"]
      });
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  this.algorithm_artifact_path = "";
  this.apply_target_type = 2;
  this.apply_time_range = null;
  this.category_id = "";
  this.category_name = "";
  this.common_keyframes = [];
  this.disable_effect_faces = [];
  this.effect_id = effect.common_attr.effect_id;
  this.formula_id = "";
  this.id = uuidv4();
  this.name = effect.common_attr.title;
  this.path = "";
  this.platform = "all";
  this.render_index = 0;
  this.request_id = "";
  this.resource_id = effect.common_attr.id;
  this.source_platform = 0;
  this.time_range = null;
  this.track_render_index = 0;
  this.type = "video_effect";
  this.value = 1.0;
  this.version = "";
});
module.exports = {
  Effects: Effects
};