"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
//创建文字内容
var _require = require('uuid'),
  uuidv4 = _require.v4;
var TextMaterial = /*#__PURE__*/_createClass(function TextMaterial() {
  var content = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '你好，剪映';
  _classCallCheck(this, TextMaterial);
  this.add_type = 0;
  this.alignment = 1;
  this.background_alpha = 1.0;
  this.background_color = "";
  this.background_height = 0.14;
  this.background_horizontal_offset = 0.0;
  this.background_round_radius = 0.0;
  this.background_style = 0;
  this.background_vertical_offset = 0.0;
  this.background_width = 0.14;
  this.base_content = "";
  this.bold_width = 0.0;
  this.border_alpha = 1.0;
  this.border_color = "";
  this.border_width = 0.08;
  this.caption_template_info = {
    category_id: "",
    category_name: "",
    effect_id: "",
    is_new: false,
    path: "",
    request_id: "",
    resource_id: "",
    resource_name: "",
    source_platform: 0
  };
  this.check_flag = 7;
  this.combo_info = {
    text_templates: []
  };
  var generator = new TextStyleGenerator(content);
  generator.addStyle(0, content.length, "#ffffff", 15);
  this.content = generator.generateJson();
  this.fixed_height = -1.0;
  this.fixed_width = -1.0;
  this.font_category_id = "";
  this.font_category_name = "";
  this.font_id = "";
  this.font_name = "";
  this.font_path = "/Applications/VideoFusion-macOS.app/Contents/Resources/Font/SystemFont/zh-hans.ttf";
  this.font_resource_id = "";
  this.font_size = 15.0;
  this.font_source_platform = 0;
  this.font_team_id = "";
  this.font_title = "none";
  this.font_url = "";
  this.fonts = [];
  this.force_apply_line_max_width = false;
  this.global_alpha = 1.0;
  this.group_id = "";
  this.has_shadow = false;
  this.id = uuidv4();
  this.initial_scale = 1.0;
  this.inner_padding = -1.0;
  this.is_rich_text = true;
  this.italic_degree = 0;
  this.ktv_color = "";
  this.language = "";
  this.layer_weight = 1;
  this.letter_spacing = 0.0;
  this.line_feed = 1;
  this.line_max_width = 0.82;
  this.line_spacing = 0.02;
  this.multi_language_current = "none";
  this.name = "";
  this.original_size = [];
  this.preset_category = "";
  this.preset_category_id = "";
  this.preset_has_set_alignment = false;
  this.preset_id = "";
  this.preset_index = 0;
  this.preset_name = "";
  this.recognize_task_id = "";
  this.recognize_type = 0;
  this.relevance_segment = [];
  this.shadow_alpha = 0.9;
  this.shadow_angle = -45.0;
  this.shadow_color = "";
  this.shadow_distance = 5.0;
  this.shadow_point = {
    x: 0.6363961030678928,
    y: -0.6363961030678927
  };
  this.shadow_smoothing = 0.45;
  this.shape_clip_x = false;
  this.shape_clip_y = false;
  this.source_from = "";
  this.style_name = "";
  this.sub_type = 0;
  this.subtitle_keywords = null;
  this.subtitle_template_original_fontsize = 0.0;
  this.text_alpha = 1.0;
  this.text_color = "#ffde00";
  this.text_curve = null;
  this.text_preset_resource_id = "";
  this.text_size = 30;
  this.text_to_audio_ids = [];
  this.tts_auto_update = false;
  this.type = "subtitle";
  this.typesetting = 0;
  this.underline = false;
  this.underline_offset = 0.22;
  this.underline_width = 0.05;
  this.use_effect_default_color = false;
  this.words = {
    end_time: [],
    start_time: [],
    text: []
  };
});
var TextStyleGenerator = /*#__PURE__*/function () {
  function TextStyleGenerator(text) {
    _classCallCheck(this, TextStyleGenerator);
    this.text = text;
    this.styles = [];
  }
  return _createClass(TextStyleGenerator, [{
    key: "hexToRgbArray",
    value: function hexToRgbArray(hex) {
      // 去掉开头的 '#' 符号
      hex = hex.replace(/^#/, '');

      // 将颜色分量转换为十进制并归一化到 [0, 1] 范围
      var bigint = parseInt(hex, 16);
      var r = (bigint >> 16 & 255) / 255;
      var g = (bigint >> 8 & 255) / 255;
      var b = (bigint & 255) / 255;
      return [r, g, b];
    }
  }, {
    key: "addStyle",
    value: function addStyle(start, end, hexColor, size) {
      var useLetterColor = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
      var style = {
        fill: {
          content: {
            solid: {
              color: this.hexToRgbArray(hexColor)
            }
          }
        },
        range: [start, end],
        size: size,
        font: {
          id: "",
          path: ""
        }
      };
      if (useLetterColor) {
        style.useLetterColor = true;
      }
      this.styles.push(style);
    }
  }, {
    key: "generateJson",
    value: function generateJson() {
      return JSON.stringify({
        styles: this.styles,
        text: this.text
      });
    }
  }]);
}(); // 使用示例
// const generator = new TextStyleGenerator("默认文本ab文本");
// generator.addStyle(0, 3, "#ffffff", 15);
// generator.addStyle(3, 4, "#fa864c", 15, true);
// generator.addStyle(4, 6, "#ffffff", 15);
// generator.addStyle(6, 7, "#fa864c", 15, true);
// generator.addStyle(7, 8, "#ffffff", 15);
// console.log(generator.generateJson());
module.exports = {
  TextMaterial: TextMaterial,
  TextStyleGenerator: TextStyleGenerator
};