"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var _require = require('uuid'),
  uuidv4 = _require.v4;
var _require2 = require('./Segments'),
  Segments = _require2.Segments;

// 定义一个常量类 TrackTypes
var TrackTypes = /*#__PURE__*/_createClass(function TrackTypes() {
  _classCallCheck(this, TrackTypes);
}); // 定义一个类 Track
_defineProperty(TrackTypes, "TEXT", 'text');
_defineProperty(TrackTypes, "VIDEO", 'video');
_defineProperty(TrackTypes, "EFFECT", 'effect');
_defineProperty(TrackTypes, "AUDIO", 'audio');
_defineProperty(TrackTypes, "STICKER", 'sticker');
var Track = /*#__PURE__*/function () {
  function Track() {
    var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : TrackTypes.TEXT;
    _classCallCheck(this, Track);
    // 将 track 对象的属性直接作为类属性
    this.attribute = 0;
    this.flag = 3;
    this.id = uuidv4();
    this.segments = [];
    this.type = type;
  }
  return _createClass(Track, [{
    key: "addSegments",
    value: function addSegments(material_id, start, duration) {
      var segments = new Segments(material_id, start, duration);
      // 修改这里使用 this.segments 而不是 this.track.segments
      this.segments.push(segments);
      return segments;
    }
  }]);
}();
module.exports = {
  Track: Track,
  TrackTypes: TrackTypes
};