"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
var _require = require('./data/transitions/cn_transitions'),
  find_transition_by_effect_id = _require.find_transition_by_effect_id;
var _require2 = require('uuid'),
  uuidv4 = _require2.v4;
var Transitions = /*#__PURE__*/_createClass(function Transitions(effect_id) {
  _classCallCheck(this, Transitions);
  var transition = find_transition_by_effect_id(effect_id);
  var sdk_extra = JSON.parse(transition.common_attr.sdk_extra);
  this.category_id = "";
  this.category_name = "";
  this.duration = parseInt(sdk_extra.transition.defaultDura * 1000000);
  this.effect_id = transition.common_attr.effect_id;
  this.id = uuidv4();
  this.is_overlap = sdk_extra.transition.isOverlap;
  this.name = transition.common_attr.title;
  this.platform = "all";
  this.resource_id = transition.common_attr.id;
  this.type = "transition";
});
module.exports = {
  Transitions: Transitions
};