"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
var _require = require('uuid'),
  uuidv4 = _require.v4;

// 定义素材类型常量
var MATERIAL_TYPE = {
  VIDEO: 'video',
  PHOTO: 'photo'
};
var VideoMaterial = /*#__PURE__*/_createClass(function VideoMaterial(video_path) {
  var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 5 * 1000 * 1000;
  var width = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1080;
  var height = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1080;
  var type = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : MATERIAL_TYPE.VIDEO;
  _classCallCheck(this, VideoMaterial);
  this.aigc_type = "none";
  this.audio_fade = null;
  this.cartoon_path = "";
  this.category_id = "";
  this.category_name = "";
  this.check_flag = 63487;
  this.crop = {
    lower_left_x: 0.0,
    lower_left_y: 1.0,
    lower_right_x: 1.0,
    lower_right_y: 1.0,
    upper_left_x: 0.0,
    upper_left_y: 0.0,
    upper_right_x: 1.0,
    upper_right_y: 0.0
  };
  this.crop_ratio = "free";
  this.crop_scale = 1.0;
  this.duration = duration;
  this.extra_type_option = 0;
  this.formula_id = "";
  this.freeze = null;
  this.has_audio = false;
  this.height = height;
  this.id = uuidv4();
  this.intensifies_audio_path = "";
  this.intensifies_path = "";
  this.is_ai_generate_content = false;
  this.is_copyright = false;
  this.is_text_edit_overdub = false;
  this.is_unified_beauty_mode = false;
  this.local_id = "";
  this.local_material_id = "";
  this.material_id = "";
  this.material_name = uuidv4();
  this.material_url = "";
  this.matting = {
    flag: 0,
    has_use_quick_brush: false,
    has_use_quick_eraser: false,
    interactiveTime: [],
    path: "",
    strokes: []
  };
  this.media_path = "";
  this.object_locked = null;
  this.origin_material_id = "";
  this.path = video_path;
  this.picture_from = "none";
  this.picture_set_category_id = "";
  this.picture_set_category_name = "";
  this.request_id = "";
  this.reverse_intensifies_path = "";
  this.reverse_path = "";
  this.smart_motion = null;
  this.source = 0;
  this.source_platform = 0;
  this.stable = {
    matrix_path: "",
    stable_level: 0,
    time_range: {
      duration: duration,
      start: 0
    }
  };
  this.team_id = "";
  this.type = type;
  this.video_algorithm = {
    algorithms: [],
    complement_frame_config: null,
    deflicker: null,
    gameplay_configs: [],
    motion_blur_config: null,
    noise_reduction: null,
    path: "",
    quality_enhance: null,
    time_range: null
  };
  this.width = width;
});
module.exports = {
  VideoMaterial: VideoMaterial,
  MATERIAL_TYPE: MATERIAL_TYPE
};