"use strict";

//创建文字动画
var _require = require('uuid'),
  uuidv4 = _require.v4;
var _require2 = require('./data/video/video_animations'),
  get_video_loop_Effect_by_title = _require2.get_video_loop_Effect_by_title,
  get_video_ruchang_Effect_by_title = _require2.get_video_ruchang_Effect_by_title,
  get_video_chuchang_Effect_by_title = _require2.get_video_chuchang_Effect_by_title;

//创建一个文字动画返回资源
function add_video_animations() {
  var in_title = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var out_title = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var loop_title = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";
  var video_animations = [];
  if (in_title) {
    var ruchang_ani = get_video_ruchang_Effect_by_title(in_title);
    video_animations.push(ruchang_ani);
  }
  if (out_title) {
    var chuchang_ani = get_video_chuchang_Effect_by_title(out_title);
    video_animations.push(chuchang_ani);
  }
  if (loop_title) {
    var loop_ani = get_video_loop_Effect_by_title(loop_title);
    video_animations.push(loop_ani);
  }
  var animations = {
    "animations": video_animations,
    "id": uuidv4(),
    "multi_language_current": "none",
    "type": "sticker_animation"
  };
  return animations;
}
module.exports = {
  add_video_animations: add_video_animations
};