"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _createForOfIteratorHelper(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (!t) { if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var _n = 0, F = function F() {}; return { s: F, n: function n() { return _n >= r.length ? { done: !0 } : { done: !1, value: r[_n++] }; }, e: function e(r) { throw r; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var o, a = !0, u = !1; return { s: function s() { t = t.call(r); }, n: function n() { var r = t.next(); return a = r.done, r; }, e: function e(r) { u = !0, o = r; }, f: function f() { try { a || null == t["return"] || t["return"](); } finally { if (u) throw o; } } }; }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var _require = require('uuid'),
  uuidv4 = _require.v4;
var _require2 = require("./Keyframe"),
  KeyframeProperty = _require2.KeyframeProperty;
var _require3 = require("./Keyframe"),
  KeyframeList = _require3.KeyframeList;
var _require4 = require("./Keyframe"),
  Keyframe = _require4.Keyframe;
var Segments = /*#__PURE__*/function () {
  function Segments(material_id, start, duration) {
    _classCallCheck(this, Segments);
    this.caption_info = null;
    this.cartoon = false;
    this.clip = {
      alpha: 1.0,
      flip: {
        horizontal: false,
        vertical: false
      },
      rotation: 0.0,
      scale: {
        x: 1.0,
        y: 1.0
      },
      transform: {
        x: 0.0,
        y: 0.0
      }
    };
    this.common_keyframes = [];
    this.enable_adjust = true;
    this.enable_color_correct_adjust = false;
    this.enable_color_curves = true;
    this.enable_color_match_adjust = false;
    this.enable_color_wheels = true;
    this.enable_lut = true;
    this.enable_smart_color_adjust = false;
    this.extra_material_refs = [];
    this.group_id = "";
    this.hdr_settings = {
      intensity: 1.0,
      mode: 1,
      nits: 1000
    };
    this.id = uuidv4();
    this.intensifies_audio = false;
    this.is_placeholder = false;
    this.is_tone_modify = false;
    this.keyframe_refs = [];
    this.last_nonzero_volume = 1.0;
    this.material_id = material_id;
    this.render_index = 1;
    this.responsive_layout = {
      enable: false,
      horizontal_pos_layout: 0,
      size_layout: 0,
      target_follow: "",
      vertical_pos_layout: 0
    };
    this.reverse = false;
    this.source_timerange = {
      duration: duration,
      start: 0
    };
    this.speed = 1.0;
    this.target_timerange = {
      duration: duration,
      start: start
    };
    this.template_id = "";
    this.template_scene = "default";
    this.track_attribute = 0;
    this.track_render_index = 3;
    this.uniform_scale = {
      on: true,
      value: 1.0
    };
    this.visible = true;
    this.volume = 1.0;
  }
  return _createClass(Segments, [{
    key: "addKeyframe",
    value: function addKeyframe(_property, timeOffset, value) {
      if ((_property === KeyframeProperty.SCALE_X || _property === KeyframeProperty.SCALE_Y) && this.uniform_scale.on) {
        this.uniform_scale.on = false;
      } else if (_property === KeyframeProperty.UNIFORM_SCALE) {
        if (!this.uniform_scale.on) {
          throw new Error("已设置 scale_x 或 scale_y 时, 不能再设置 uniform_scale");
        }
        _property = KeyframeProperty.SCALE_X;
      }
      if (typeof timeOffset === 'string') {
        timeOffset = this.tim(timeOffset);
      }
      var _iterator = _createForOfIteratorHelper(this.common_keyframes),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var kfListJson = _step.value;
          if (kfListJson.property_type === _property) {
            // 找到匹配的kfList，重新创建KeyframeList对象
            var _kfList = new KeyframeList(_property);
            _kfList.keyframes = kfListJson.keyframe_list.map(function (kf) {
              return new Keyframe(kf.time_offset, kf.values[0]);
            });
            _kfList.addKeyframe(timeOffset, value);
            kfListJson.keyframe_list = _kfList.keyframes.map(function (kf) {
              return kf.exportJson();
            });
            return this;
          }
        }

        // 如果没有找到匹配的kfList，创建一个新的
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      var kfList = new KeyframeList(_property);
      kfList.addKeyframe(timeOffset, value);
      this.common_keyframes.push(kfList.exportJson());
      return this;
    }
  }, {
    key: "tim",
    value: function tim(timeString) {
      // 解析时间字符串为微秒
      return parseInt(timeString, 10); // 简单示例
    }
  }]);
}();
module.exports = {
  Segments: Segments
};