"use strict";

//创建文字动画
var _require = require('uuid'),
  uuidv4 = _require.v4;
var _require2 = require('./data/text/text_animations'),
  get_ruchang_Effect_by_title = _require2.get_ruchang_Effect_by_title,
  get_chuchang_Effect_by_title = _require2.get_chuchang_Effect_by_title,
  get_loop_Effect_by_title = _require2.get_loop_Effect_by_title;
//创建一个文字动画返回资源
function add_text_animations() {
  var ruchang_name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var chuchang_name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
  var xuhuan_name = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";
  var text_animations = [];
  if (ruchang_name) {
    var ruchang_ani = get_ruchang_Effect_by_title(ruchang_name);
    text_animations.push(ruchang_ani);
  }
  if (chuchang_name) {
    var chuchang_ani = get_chuchang_Effect_by_title(chuchang_name);
    text_animations.push(chuchang_ani);
  }
  if (xuhuan_name) {
    var loop_ani = get_loop_Effect_by_title(xuhuan_name);
    text_animations.push(loop_ani);
  }
  var animations = {
    "animations": text_animations,
    "id": uuidv4(),
    "multi_language_current": "none",
    "type": "sticker_animation"
  };
  return animations;
}
module.exports = {
  add_text_animations: add_text_animations
};